(*

WARNING this is a PRE-ALPHA release.

English
=======

The Legal Disclaimer :
----------------------

THE INFORMATION AND CODE PROVIDED HERE UNDER (COLLECTIVELY REFERRED TO AS
"SOFTWARE") IS PROVIDED AS IS WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
IN NO EVENT SHALL Pierre Rougier (The Author) BE LIABLE FOR ANY DAMAGES
WHATSOEVER INCLUDING DIRECT, INDIRECT, INCIDENTAL, CONSEQUENTIAL,
LOSS OF BUSINESS PROFITS OR SPECIAL DAMAGES,
EVEN IF Pierre Rougier  HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
SOME STATES DO NOT ALLOW THE EXCLUSION OR LIMITATION OF LIABILITY FOR
CONSEQUENTIAL OR INCIDENTAL DAMAGES SO THE FOREGOING LIMITATION MAY NOT
APPLY. IN SUCH A SPECIAL CASE YOU HAVE NOT THE RIGHT TO USE THIS SOFTWARE.


Additional note :
-----------------

THIS SOFTWARE IS NOT DONATED TO PULIC DOMAIN. ITS USE IS FREE BUT I KEEP MY
COPYRIGHTS.


Support:
--------

   - For more information about the LMKit community, please look at :
 http://groups.yahoo.com/group/LMKit

   - Look for new versions at:
 http://groups.yahoo.com/group/LMKit/files/

   - Leave the LMKit community by sending an empty e-mail to:
 LMKit-unsubscribe@yahoogroupes.fr

Install
-------

 In focus to compile LMKit you have to install first :

 kbmmemtb253g
 You can find kbmmemtb253g there :

 http://www.optical.dk/delphi/download/kbmMemTable/kbmmemtb253g.zip

 The RxLIb.


pierre.rougier@logiciels-rougier.com

Pierre Rougier
http://groups.yahoo.com/group/LMKit

*)

(*

Franais
--------

 ATTENTION.
 CETTE APPLICATION N'EST PAS UTILISABLE EN L'ETAT.
 SEULES LES SOURCES SONT FOURNIES.


 Licenses version 0.2.1

But de l'application :
Ceci est un programme en cours de dveloppement qui a pour but de
grer des licences de sharewares.
Il est crit en Delphi 4.3 avec la base de donnes Paradox.
De fait seul un dveloppeur peut actuellement l'installer.

Support:
--------

   - Pour plus d'infos sur LMKit, merci de vous inscrire  ce groupe :
 http://groups.yahoo.com/group/LMKit

   - Les nouvelles versions de LMKit seront maintenant annones sur :
 http://groups.yahoo.com/group/LMKit/files/


Installation
------------

 Pour pouvoir compiler LMKit, il vous faut d'abord tlcharger :

 kbmmemtb253g
 Vous pouvez tlcharger kbmmemtb253g ici :

 http://www.optical.dk/delphi/download/kbmMemTable/kbmmemtb253g.zip

 The RxLIb.


pierre.rougier@logiciels-rougier.com

Pierre Rougier
http://www.logiciels-rougier.com

*)

unit uMainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, ImgList, ActnList, Menus, ExtCtrls, StdCtrls, DBGrids,
  DBCtrls, Db, ComCtrls, RXDBCtrl, ToolWin, DBTables, kbmMemTable;

type
  TfrMainForm = class(TForm)

// Menu
    ActionList1: TActionList;
    ImageList1: TImageList;

    MainMenu1: TMainMenu;
    miFichier: TMenuItem;
    miIndexs: TMenuItem;
    miIxNomPre: TMenuItem;
    miIndexParCle: TMenuItem;

    miHelp: TMenuItem;
    Help1: TMenuItem;
    acHelp: TAction;

    miTools: TMenuItem;
    acCreateTables: TAction;

    acQuitter: TAction;
    miExit: TMenuItem;

    StatusBar1: TStatusBar;

// Page Control
    PageControl1: TPageControl;
    TabSheetCustomers: TTabSheet;
    TabSheetProducts: TTabSheet;
    TabSheetCommands: TTabSheet;
    dbgCustomers: TRxDBGrid;
    dbgProducts: TRxDBGrid;

// ToolBar Customers
    ToolBarCustomers: TToolBar;
    acNewCustomer: TAction;
    acEditCustomer: TAction;
    acDeleteCustomer: TAction;
    tbtNewCustomer: TToolButton;
    tbtEditCustomer: TToolButton;
    tbtDeleteCustomer: TToolButton;


//  ToolBar Command
    ToolBarCommand: TToolBar;
    acNewCommand: TAction;
    acEditCommand: TAction;
    acDeleteCommand: TAction;
    tbtNewCommand: TToolButton;
    tbtEditCommand: TToolButton;
    tbtDeleteCommand: TToolButton;

//  ToolBar Products
    ToolBarProducts: TToolBar;
    acNewProduct: TAction;
    acEditProduct: TAction;
    acDeleteProduct: TAction;
    tbtNewProduct: TToolButton;
    tbtEditProduct: TToolButton;
    tbtDeleteProduct: TToolButton;

    CreateTables1: TMenuItem;
    dbgCommand: TDBGrid;

    procedure FormCreate(Sender: TObject);
    procedure miIxNomPreClick(Sender: TObject);
    procedure miIndexParCleClick(Sender: TObject);
    procedure acQuitterExecute(Sender: TObject);

    procedure acNewCustomerExecute(Sender: TObject);
    procedure acEditCustomerExecute(Sender: TObject);
    procedure acDeleteCustomerExecute(Sender: TObject);

    procedure acNewCommandExecute(Sender: TObject);
    procedure acEditCommandExecute(Sender: TObject);
    procedure acDeleteCommandExecute(Sender: TObject);

    procedure acNewProductExecute(Sender: TObject);
    procedure acEditProductExecute(Sender: TObject);
    procedure acDeleteProductExecute(Sender: TObject);

    procedure PageControl1Change(Sender: TObject);

    procedure dbgCustomersDblClick(Sender: TObject);
    procedure dbgCustomersKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);

    procedure dbgProductDblClick(Sender: TObject);
    procedure dbgProductKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);

    procedure dbgCommandDblClick(Sender: TObject);
    procedure dbgCommandKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure acCreateTablesExecute(Sender: TObject);

  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  frMainForm: TfrMainForm;

implementation

uses uDM, uCustomer, uProduct, uCommand, uConst;

{$R *.DFM}

procedure TfrMainForm.FormCreate(Sender: TObject);
begin
  gDBPath := ExtractFilePath(Application.ExeName) + 'D\';
  PageControl1.ActivePage := TabSheetCustomers;
end;

procedure TfrMainForm.acQuitterExecute(Sender: TObject);
begin
  Close;
end;

procedure TfrMainForm.acCreateTablesExecute(Sender: TObject);
var
  Options: TkbmMemTableSaveFlags;
begin
  Options := [mtfSaveData, mtfSaveCalculated, mtfSaveFieldKind, mtfSaveBlobs,
    mtfSaveDef, mtfSaveLookup];

  DM.tbCustomer.Close;
  DM.tbProduct.Close;
  DM.tbCommand.Close;
  DM.tbCommandLigne.Close;

  DM.tbCustomer.Open;
  DM.tbCustomer.SaveToBinaryFile(gDBPath + 'Customer.bin', Options);

  DM.tbProduct.Open;
  DM.tbProduct.SaveToBinaryFile(gDBPath + 'Product.bin', Options);

  DM.tbCommand.Open;
  DM.tbCommand.SaveToBinaryFile(gDBPath + 'Command.bin', Options);

  DM.tbCommandLigne.Open;
  DM.tbCommandLigne.SaveToBinaryFile(gDBPath + 'CommandLigne.bin', Options);

end;

procedure TfrMainForm.miIndexParCleClick(Sender: TObject);
begin
  miIndexParCle.Checked := true;
  DM.tbCustomer.IndexName := '';
  DM.tbCustomer.First;
end;

procedure TfrMainForm.miIxNomPreClick(Sender: TObject);
begin
  miIxNomPre.Checked := true;
  DM.tbCustomer.IndexName := 'ixNomPrenom';
  DM.tbCustomer.First;
end;

procedure TfrMainForm.acNewCustomerExecute(Sender: TObject);
begin
  DM.tbCustomer.Insert;
  frCustomer := TfrCustomer.create(application);
  frCustomer.ShowModal;
  frCustomer.Free;
  dbgCustomers.Invalidate;
end;

procedure TfrMainForm.acEditCustomerExecute(Sender: TObject);
begin
  frCustomer := TfrCustomer.create(application);
  frCustomer.ShowModal;
  frCustomer.Free;
  dbgCustomers.Invalidate;
end;

procedure TfrMainForm.acDeleteCustomerExecute(Sender: TObject);
begin
  if MessageDlg('Delete the highlighted record ?',
    mtConfirmation, [mbYes, mbNo], 0) = idYes then
    DM.tbCustomer.Delete;
end;

procedure TfrMainForm.acNewCommandExecute(Sender: TObject);
begin
  DM.tbCommand.Insert;
  frCommand.ShowModal;
  dbgCommand.Invalidate;
end;

procedure TfrMainForm.acEditCommandExecute(Sender: TObject);
begin
  frCommand.ShowModal;
  dbgCommand.Invalidate;
end;

procedure TfrMainForm.acDeleteCommandExecute(Sender: TObject);
begin
  if MessageDlg('Delete the highlighted record ?',
    mtConfirmation, [mbYes, mbNo], 0) = idYes then
    DM.tbCommand.Delete;
end;

procedure TfrMainForm.acNewProductExecute(Sender: TObject);
begin
  DM.tbProduct.Insert;
  frProduct.ShowModal;
  dbgProducts.Invalidate;
end;

procedure TfrMainForm.acEditProductExecute(Sender: TObject);
begin
  frProduct.ShowModal;
  dbgProducts.Invalidate;
end;

procedure TfrMainForm.acDeleteProductExecute(Sender: TObject);
begin
  if MessageDlg('Delete the highlighted record ?',
    mtConfirmation, [mbYes, mbNo], 0) = idYes then
    DM.tbProduct.Delete;
end;

procedure TfrMainForm.PageControl1Change(Sender: TObject);
begin
  case PageControl1.ActivePage.PageIndex of
    0: begin
        ToolBarCustomers.Enabled := True;
        ToolBarCommand.Enabled := False;
        ToolBarProducts.Enabled := False;
      end;
    1: begin
        ToolBarCustomers.Enabled := False;
        ToolBarCommand.Enabled := True;
        ToolBarProducts.Enabled := False;
      end;
    2: begin
        ToolBarCustomers.Enabled := False;
        ToolBarCommand.Enabled := False;
        ToolBarProducts.Enabled := True;
      end;
  end;

end;

procedure TfrMainForm.dbgCustomersDblClick(Sender: TObject);
begin
  frCustomer := TfrCustomer.create(application);
  frCustomer.ShowModal;
  frCustomer.Free;
  dbgCustomers.Invalidate;
end;

procedure TfrMainForm.dbgCustomersKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = VK_RETURN then
  begin
    frCustomer := TfrCustomer.create(application);
    frCustomer.ShowModal;
    frCustomer.Free;
  end;

  dbgCustomers.Invalidate;
end;

procedure TfrMainForm.dbgCommandDblClick(Sender: TObject);
begin
  frCommand.ShowModal;
  dbgCommand.Invalidate;
end;

procedure TfrMainForm.dbgCommandKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = VK_RETURN then
    frCommand.ShowModal;

  dbgCommand.Invalidate;
end;

procedure TfrMainForm.dbgProductDblClick(Sender: TObject);
begin
  frProduct.ShowModal;
  dbgProducts.Invalidate;
end;

procedure TfrMainForm.dbgProductKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = VK_RETURN then
    frProduct.ShowModal;

  dbgProducts.Invalidate;
end;

end.

